/*
   FILNAME:    

   PURPOSE:   

   CREATED BY:    Per Ghosh
   ENVIRONMENT:	Visual C++


INFO:
*/

#ifndef __PGSTORAGEMANAGER_H_
#define __PGSTORAGEMANAGER_H_

#ifndef STORAGE_T_RW_SE
   #define STORAGE_T_RW_SE     STGM_TRANSACTED | STGM_READWRITE | STGM_SHARE_EXCLUSIVE
   #define STORAGE_D_RW_SE     STGM_DIRECT | STGM_READWRITE | STGM_SHARE_EXCLUSIVE
#endif

class CPGStorage;

class CPGStorageManager : public CObject
{
	DECLARE_DYNAMIC(CPGStorageManager)

public:
	CPGStorageManager();           // protected constructor used by dynamic creation
	virtual ~CPGStorageManager();

// Attributes
public:
	static HRESULT m_hResult;

   CPGStorage* m_pstorageActive;     // Pointer to the active CPGStorage-class
   CObList     m_listToStorage;      // List with connected storages

// Get/Set
public:
   CPGStorage* GetActiveStorage() { return m_pstorageActive; }

// Operations
public:
	BOOL CreateStorage( LPCSTR pszName, DWORD dwFlags = STORAGE_T_RW_SE );
	BOOL CreateStorage( const WCHAR* pwName, DWORD dwFlags = STORAGE_T_RW_SE );

   BOOL OpenStorage( LPCSTR pszName, DWORD dwFlags = STORAGE_T_RW_SE );
	BOOL OpenStorage( const WCHAR* pwName, DWORD dwFlags = STORAGE_T_RW_SE );

   BOOL SetActiveStorage( const WCHAR* pwName );
   BOOL SetActiveStorage( LPCSTR pwName );


// Implementation
public:
   //WCHAR* ConvertToWCHAR( LPCSTR pszText );
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};




#endif