/*
   FILNAME:       PGStream.h

   PURPOSE:   

   CREATED BY:    Per Ghosh
   ENVIRONMENT:   Visual C++

INFO:
*/

#ifndef STORAGE_T_RW_SE
   #define STORAGE_T_RW_SE     STGM_TRANSACTED | STGM_READWRITE | STGM_SHARE_EXCLUSIVE
   #define STORAGE_D_RW_SE     STGM_DIRECT | STGM_READWRITE | STGM_SHARE_EXCLUSIVE
#endif

class CPGStream : public CFile
{
	DECLARE_DYNAMIC(CPGStream)

public:
	CPGStream();
	CPGStream( IStream* pStream );
	CPGStream( IStream* pStream, const WCHAR* pwName );

   virtual ~CPGStream();

// Attributes
public:
   static HRESULT m_hResult;

   IStream* m_pIStream;
   WCHAR*   m_pwName;

// Get/Set
public:
   IStream* GetIStream() { return m_pIStream; }

// Operations
public:
   BOOL CreateMemoryStream();
	BOOL CreateStream( IStorage* pStorage, const WCHAR* pwName, DWORD dwFlags = STORAGE_T_RW_SE );
	BOOL OpenStream( IStorage* pStorage, const WCHAR* pwName, DWORD dwFlags = STORAGE_T_RW_SE );

// Overrides
public:
   virtual LONG  Seek(LONG lOffset, UINT uFromPos);
 	virtual DWORD GetPosition() const;
   virtual UINT  Read(void* lpBuf, UINT nCount);
	virtual void  Write(const void* lpBuf, UINT nCount);
   virtual void  Close();

// Implementation
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};
