/*
   FILNAME:       PGX_String.cpp

   PURPOSE:   

   CREATED BY:    Per Ghosh
   ENVIRONMENT:   Visual C++

INFO:
*/

#include "stdafx.h"

//-------------------------------------------------------------------------------------------------
void pgx_pCHAR_to_pWCHAR( const char* pszText, unsigned short* pwText )
{
	ASSERT(AfxIsValidAddress(pwText, (strlen(pszText) + 1) * sizeof(short) ));

   int iCounter = 0;

   while( pszText[iCounter] )
   {
      pwText[iCounter] = (unsigned short)(BYTE)pszText[iCounter];

      iCounter++;
   }

   pwText[iCounter] = 0;
}

//-------------------------------------------------------------------------------------------------
void pgx_pWCHAR_to_pCHAR( const unsigned short* pwText, char* pszText )
{
	ASSERT(AfxIsValidAddress(pwText, wcslen(pwText) + 1));

   int iCounter = 0;

   while( pwText[iCounter] )
   {
      pszText[iCounter] = (char)(WORD)pwText[iCounter];

      iCounter++;
   }

   pszText[iCounter] = '\0';
}

//-------------------------------------------------------------------------------------------------
unsigned short* pgx_new_pWCHAR_from_pCHAR( const char* pszText )
{
   int             iCounter = 0;
   unsigned short* pwText;

   pwText = new unsigned short[strlen(pszText) + 1];

   while( pszText[iCounter] )
   {
      pwText[iCounter] = (unsigned short)(BYTE)pszText[iCounter];

      iCounter++;
   }

   pwText[iCounter] = 0;
   
   return pwText;
}

//-------------------------------------------------------------------------------------------------
char* pgx_new_pCHAR_from_pWCHAR( const unsigned short* pwText )
{
   int   iCounter = 0;
   char* pszText;

   pszText = new char[wcslen(pwText) + 1];
   while( pwText[iCounter] )
   {
      pszText[iCounter] = (char)(WORD)pwText[iCounter];

      iCounter++;
   }

   pszText[iCounter] = 0;

   return pszText;
}